/*
 *
 * Copyright (c) 1997-1999 Scott Oaks and Henry Wong. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and
 * without fee is hereby granted.
 *
 * This sample source code is provided for example only,
 * on an unsupported, as-is basis. 
 *
 * AUTHOR MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. AUTHOR SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  AUTHOR
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 */



public class ProcessIt implements Runnable {
	String is[];
	Barrier bpStart, bp1, bp2, bpEnd;

	public ProcessIt (String sources[]) {
		is = sources;
		bpStart = new Barrier(sources.length);
		bp1 = new Barrier(sources.length);
		bp2 = new Barrier(sources.length);
		bpEnd = new Barrier(sources.length);

		for (int i=0; i < is.length; i++) {
			(new Thread(this)).start();
		}
	}

	public void run() {
		System.out.println("Starting");
		try {
			int i = bpStart.waitForRest();
			doPhaseOne(is[i]);
			bp1.waitForRest();
			doPhaseTwo(is[i]);
			bp2.waitForRest();
			doPhaseThree(is[i]);
			bpEnd.waitForRest();
			System.out.println("Exiting");
		} catch (InterruptedException ex) {};
	}

	public void doPhaseOne(String ps) {
		System.out.println("phase one -- " + ps);
	}

	public void doPhaseTwo(String ps) {
		System.out.println("phase two -- " + ps);
	}

	public void doPhaseThree(String ps) {
		System.out.println("phase three -- " + ps);
	}

	static public void main(String args[]) {
		System.out.println("Starting");
		ProcessIt pi = new ProcessIt(args);
	}
}
